-----------------------------------------------------
-- lua 파일이 여러개인 경우
-- 애드온명, 애드온내공유테이블이 ...으로 전달됨
-----------------------------------------------------
local addonName, L = ...;

--[[
[local로 선언시 주의점 ]
1.사용되기 전에 반드시 선언되어 있어야 함. 인터프리터...
  (특히 이미 있는 함수를 재정의할 경우 엉뚱한 함수가 호출될수 있음.)
2.게임의 매크로내에서 호출할수 없음.
3.동일 LUA파일에서만 읽을수 있음.

[와우 참조 코드 보기]
Using the Battle.net Desktop App
This is probably the easiest method to enable console access.

1. Click on the Blizzard logo in the top-left-hand corner and select "Settings".
2. Select "Game Settings" in the config window that appears.
3. Tick the box that says "Additional command line arguments".
4. Type -console into the text box that appears.
5. Click on the blue "Done" button to close the config window.

로긴창, 케릭터 선택창에서 자판의 ~(`) 누름.
아래 명령어 입력

ExportInterfaceFiles code
ExportInterfaceFiles art

--]]

--[[
-----------------------------------------------------------------------
-- 진득정리
-- 색지정문자 출력 패턴 : "|c" + 출력할색깔argb값 + 대상문자 + "|r"
-- ex1) 분홍색으로 "분홍색"을 출력할 경우
-- DEFAULT_CHAT_FRAME:AddMessage("|cfff48cba분홍색|r<---그외 RGB(111)에 의해 흰색", 1, 1, 1);
-- ex2) 5초뒤 사라지는 빨간글자
-- UIErrorsFrame:AddMessage("Testing", 1.0, 0.0, 0.0, 53, 5);
-- etc)
-- fff48cba : select(4, GetClassColor("PALADIN"))
-- ARGB ( 선명도(00 투명), R, G, B
-----------------------------------------------------------------------
local lmsg = format("  %s %.1f |c%s%s|r |cffcccccc%s|r",
            "|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES:14:14:0:0:64:64:0:19:22:41|t",
            123.12,
            select(4, GetClassColor("PALADIN")),
            "이름",
            "스펙"
);

DEFAULT_CHAT_FRAME:AddMessage(string.rep("-", 32), 1, 0.64, 0);
DEFAULT_CHAT_FRAME:AddMessage(lmsg, 1, 0.82, 0);
DEFAULT_CHAT_FRAME:AddMessage(string.rep("-", 32), 1, 0.64, 0);

-- 매크로에선 아래처럼(| 대신 \124 사용)
/script DEFAULT_CHAT_FRAME:AddMessage("\124cfff48cba분홍색\124r <---그외 RGB(111)에 의해 흰색", 1, 1, 1);UIErrorsFrame:AddMessage("Testing", 1.0, 0.0, 0.0, 53, 5);

-- 차단 메시지 확인용 매크로
/script DEFAULT_CHAT_FRAME:AddMessage("\<차단성공\> ".."\124cfff48c00".."몬스터".."\124r".."'s "..GetSpellLink("빛의 섬광").." ".." 차단!", 1, 0, 0);
/script DEFAULT_CHAT_FRAME:AddMessage("\<차단성공\> ".."\124cfff48c00".."몬스터".."\124r".."'s "..GetSpellLink(19750).." ".." 차단!", 1, 0, 0);
/script UIErrorsFrame:AddMessage("\<차단성공\> ".."\124cfff48c00".."몬스터".."\124r".."'s "..GetSpellLink(19750).." ".." 차단!", 1.0, 0.0, 0.0, 53, 5);



-- 링크연결
/script local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo("빛의 섬광"); DEFAULT_CHAT_FRAME:AddMessage("Spell: \124Hspell:"..spellId.."\124h\124r\124cff71d5ff["..name.."]\124r\124h");
/script local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(19750); DEFAULT_CHAT_FRAME:AddMessage("Spell: \124Hspell:"..spellId.."\124h\124r\124cff71d5ff"..name.."\124r\124h");
/script local name, rank = GetSpellInfo(19750); DEFAULT_CHAT_FRAME:AddMessage("Spell: \124Hspell:".."19750".."\124h\124r\124cff71d5ff["..name.."]\124r\124h");

/script local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo("빛의 섬광"); DEFAULT_CHAT_FRAME:AddMessage("Spell: \124Hspell:"..spellId.."\124h\124r\124cff71d5ff["..name.."]\124r\124h");

-----------------------------------------------------------------------
-- 자세히는 [UI escape sequences, GetSpellLink] 검색 참고
-----------------------------------------------------------------------

-- lua 에서의 디코드문 예)
-- GameTooltip:SetOwner(self, self:GetTop() > (GetScreenHeight() / 2) and 'ANCHOR_BOTTOM' or 'ANCHOR_TOP')

-- 20191201
-- xml 에서 MinIn 키워드가 있는경우
-- 해당 Frame에 MixIn 키워드가 있으면, MixIn(.lua) 파일안의 메소드들이 Frame의 메소드로 추가된다.


--]]

-- 전문기술 관련 API : C_TradeSkillUI
-- 현재 케릭터의 전문기술(1번째, 2번째 전문기술, 고고학, 낚시, 요리, 응급치료 순의 스킬북의 index 리턴)
-- prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();
-- name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(index)

--C_TradeSkillUI.GetAllProfessionTradeSkillLines()
--C_TradeSkillUI.GetAllRecipeIDs() - Returns a table containing all the recipe IDs for the current trade skill.
--C_TradeSkillUI.GetCategories()
--C_TradeSkillUI.GetCategoryInfo(categoryID [, returnTable])
--C_TradeSkillUI.GetRecipeInfo(recipeID [, returnTable]) - Returns information for a recipe.

--[[
--DebugPrint(C_TradeSkillUI.GetAllProfessionTradeSkillLines());
local skillLinesIDs = C_TradeSkillUI.GetAllProfessionTradeSkillLines();
--DebugPrint(skillLinesIDs[1])
--DebugPrint(C_TradeSkillUI.GetTradeSkillDisplayName(skillLinesIDs[1]));
for i=1,#skillLinesIDs do
    DebugPrint(C_TradeSkillUI.GetTradeSkillDisplayName(skillLinesIDs[i]));
end





--]]

--[[
C_TradeSkillUI EVENTS
NEW_RECIPE_LEARNED
OBLITERUM_FORGE_CLOSE
OBLITERUM_FORGE_PENDING_ITEM_CHANGED
OBLITERUM_FORGE_SHOW
TRADE_SKILL_CLOSE
TRADE_SKILL_DATA_SOURCE_CHANGED
TRADE_SKILL_DATA_SOURCE_CHANGING
TRADE_SKILL_DETAILS_UPDATE
TRADE_SKILL_LIST_UPDATE
TRADE_SKILL_NAME_UPDATE
TRADE_SKILL_SHOW
UPDATE_TRADESKILL_RECAST


--]]

--[[
		local recipeLink = C_TradeSkillUI.GetRecipeItemLink(self.selectedRecipeID);
		if ( recipeInfo.productQuality ) then
			self.Contents.RecipeName:SetTextColor(GetItemQualityColor(recipeInfo.productQuality));
		else
			self.Contents.RecipeName:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
		end
        
        
        
        local numReagents = C_TradeSkillUI.GetRecipeNumReagents(self.selectedRecipeID);
        for reagentIndex = 1, numReagents do
			local reagentName, reagentTexture, reagentCount, playerReagentCount = C_TradeSkillUI.GetRecipeReagentInfo(self.selectedRecipeID, reagentIndex);
		end
        
        
        local playerReagentCountAbbreviated = AbbreviateNumbers(playerReagentCount);
        
								C_TradeSkillUI.ClearInventorySlotFilter();
								C_TradeSkillUI.ClearRecipeCategoryFilter();
								C_TradeSkillUI.ClearRecipeSourceTypeFilter();
								C_TradeSkillUI.SetOnlyShowMakeableRecipes(false);
								C_TradeSkillUI.SetOnlyShowSkillUpRecipes(false);



function TradeSkillFrame_GetBaseRecipeID(recipeID)
	local info = C_TradeSkillUI.GetRecipeInfo(recipeID);
	while info and info.previousRecipeID do
		info = C_TradeSkillUI.GetRecipeInfo(info.previousRecipeID);
	end
	return info and info.recipeID or recipeID;
end


function NewRecipeLearnedAlertFrame_SetUp(self, recipeID)
	local tradeSkillID, skillLineName, parentTradeSkillID = C_TradeSkillUI.GetTradeSkillLineForRecipe(recipeID);
	if tradeSkillID then
		local recipeName = GetSpellInfo(recipeID);
		if recipeName then
			PlaySound(SOUNDKIT.UI_PROFESSIONS_NEW_RECIPE_LEARNED_TOAST);

			self.Icon:SetMask("Interface\\CharacterFrame\\TempPortraitAlphaMask");
			self.Icon:SetTexture(C_TradeSkillUI.GetTradeSkillTexture(tradeSkillID));

			local rank = GetSpellRank(recipeID);
			self.Title:SetText(rank and rank > 1 and UPGRADED_RECIPE_LEARNED_TITLE or NEW_RECIPE_LEARNED_TITLE);

			local rankTexture = NewRecipeLearnedAlertFrame_GetStarTextureFromRank(rank);
			if rankTexture then
				self.Name:SetFormattedText("%s %s", recipeName, rankTexture);
			else
				self.Name:SetText(recipeName);
			end
			self.tradeSkillID = parentTradeSkillID or tradeSkillID;
			self.recipeID = recipeID;
			return true;
		end
	end
	return false;
end

	local tradeSkillID, skillLineName, skillLineRank, skillLineMaxRank, skillLineModifier, parentSkillLineID, parentSkillLineName =  C_TradeSkillUI.GetTradeSkillLine();

	if (parentSkillLineName) then
		skillLineName = parentSkillLineName;
	end

		local subCategoryName = GetUnfilteredSubCategoryName(categoryID, C_TradeSkillUI.GetSubCategories(categoryID));
		if subCategoryName then
			return subCategoryName;
		end


C_TradeSkillUI.SetRecipeItemNameFilter(text);

--]]

--[[
20191205 Mixin의 이해(샘플)
---------------------------------------
-- Mixin.lua
---------------------------------------
-- where ​... are the mixins to mixin
function Mixin(object, ...)
	for i = 1, select("#", ...) do
		local mixin = select(i, ...);
		for k, v in pairs(mixin) do
			object[k] = v;
		end
	end

	return object;
end

-- where ​... are the mixins to mixin
function CreateFromMixins(...)
	return Mixin({}, ...)
end

---------------------------------------
-- Util.lua
---------------------------------------

ColorMixin = {};

function CreateColor(r, g, b, a)
	local color = CreateFromMixins(ColorMixin);
	color:OnLoad(r, g, b, a);
	return color;
end

function ColorMixin:OnLoad(r, g, b, a)
	self:SetRGBA(r, g, b, a);
end

function ColorMixin:SetRGBA(r, g, b, a)
	self.r = r;
	self.g = g;
	self.b = b;
	self.a = a;
end

function ColorMixin:GetRGB()
	return self.r, self.g, self.b;
end

---------------------------------------
-- Constants.lua
---------------------------------------
NORMAL_FONT_COLOR			= CreateColor(1.0, 0.82, 0.0);

---------------------------------------
-- XXXXXXXXX.lua
---------------------------------------
print(NORMAL_FONT_COLOR.r);
print(NORMAL_FONT_COLOR:GetRGB());

--]]

--[[
anyModKeyIsDown = IsModifierKeyDown();

aShiftKeyIsDown = IsShiftKeyDown();
aAltKeyIsDown = IsAltKeyDown();
aCtrlKeyIsDown = IsControlKeyDown();

theLeftShiftKeyIsDown = IsLeftShiftKeyDown();
theLeftAltKeyIsDown = IsLeftAltKeyDown();
theLeftCtrlKeyIsDown = IsLeftControlKeyDown();
theRightShiftKeyIsDown = IsRightShiftKeyDown();
theRightAltKeyIsDown = IsRightAltKeyDown();
theRightCtrlKeyIsDown = IsRightControlKeyDown();


    local btn = _G["myButton"];
    if( not btn ) then
        
        btn = CreateFrame("CheckButton","myButton", UIParent, "SecureActionButtonTemplate, ActionButtonTemplate");
        --local btn = CreateFrame("Button", "myButton", UIParent, "SecureActionButtonTemplate")
        --btn:SetAttribute("type", "action");
        --btn:SetAttribute("action", 6);

        btn:SetSize(100, 100);
        btn:SetPoint("CENTER", UIParent, "CENTER", -1, -1);
        
        ChangeMoveableFrame(btn);
    end

function Button.CreateButtonWidget(Parent)
	local Name = Const.ButtonNaming..Const.ButtonSeq;
	local Widget = CreateFrame("CheckButton", Name, Parent, "SecureActionButtonTemplate, ActionButtonTemplate");
	Const.ButtonSeq = Const.ButtonSeq + 1;
	Widget:SetAttribute("checkselfcast", true);
	Widget:SetAttribute("checkfocuscast", true);
	Widget:RegisterForDrag("LeftButton", "RightButton");
	--Widget:RegisterForClicks("AnyUp");
	Widget:SetScript("OnReceiveDrag", Button.OnReceiveDrag);
	Widget:SetScript("OnDragStart", Button.OnDragStart);
	
	if (Util.ForceOffCastOnKeyDown) then
		Widget:SetScript("PostClick", Button.PostClickBasic);
		Widget:SetScript("PreClick", Button.PreClickBasic);
	else
		Widget:SetScript("PostClick", Button.PostClick);
		Widget:SetScript("PreClick", Button.PreClick);
	end
	
	--The ActionButtonTemplate does not include the following (which will be created here)
	--FloatingBG	(e.g. MultiBarButtonTemplate)
	local FloatingBG = Widget:CreateTexture(Name.."FloatingBG", "BACKGROUND", nil, -1);
	FloatingBG:SetTexture("Interface\\Buttons\\UI-Quickslot");
	FloatingBG:SetAlpha(0.4);
	FloatingBG:SetPoint("TOPLEFT", -15, 15);
	FloatingBG:SetPoint("BOTTOMRIGHT", 15, -15);

	--AutoCastable	(e.g. PetActionButtonTemplate)
	local AutoCastable = Widget:CreateTexture(Name.."AutoCastable", "OVERLAY");
	AutoCastable:SetTexture("Interface\\Buttons\\UI-AutoCastableOverlay");
	AutoCastable:SetSize(70, 70);
	AutoCastable:SetPoint("CENTER", 0, 0);
	AutoCastable:Hide();
	
	--AutoCast
	local Shine = CreateFrame("FRAME", Name.."Shine", Widget, "AutoCastShineTemplate");
	Shine:SetSize(34, 34);
	Shine:SetPoint("CENTER", 0, 0);
	
	--_G[Widget:GetName().."HotKey"]:ClearAllPoints();
	--_G[Widget:GetName().."HotKey"]:SetPoint("TOPLEFT", Widget, "TOPLEFT", 1, -2);
	Widget.action = 10000;
	if (Util.LBFMasterGroup) then
		Util.LBFMasterGroup:AddButton(Widget);
	end
	return Widget;
end

function Button.OnReceiveDrag(Widget)
	local self = Widget.ParentButton;
	if (not InCombatLockdown()) then
		if (GetCursorInfo()) then
			Util.StoreCursor(self:GetCursor());
			if (self:SetCommandFromTriplet(GetCursorInfo())) then
				Util.SetCursor(Util.GetStoredCursor());
			end
		elseif (UILib.GetDragInfo()) then
			Util.StoreCursor(self:GetCursor());
			if (self:SetCommandFromTriplet(UILib.GetDragInfo())) then
				Util.SetCursor(Util.GetStoredCursor());
			end
		end
	end
end
--]]

--[[
-- 전투시작, 종료 이벤트(PLAYER_ENTER_COMBAT and PLAYER_LEAVE_COMBAT are for *MELEE* combat only)
PLAYER_REGEN_DISABLED
PLAYER_REGEN_ENABLED

--]]
-- 문자열 함수 loadstring
local func = assert(loadstring([[
  return function(a,b)
    local result = a+b;
    return result;
  end
]]));

--[[
userdefFunc = func();

meaning_of_life_the_universe_and_everything = userdefFunc(38, 4);


--]]


-- 어그로 관련 이벤트 
-- UNIT_THREAT_LIST_UPDATE
-- UNIT_THREAT_SITUATION_UPDATE
--
-- UnitThreatSituation, UnitDetailedThreatSituation 차이는 세부적인 정보가 있고, 없고의 차이뿐.
-- local threatStatus = UnitThreatSituation("player", unitFrame.displayedUnit)
-- local isTanking, threatStatus, threatpct, rawthreatpct,threatvalue = UnitDetailedThreatSituation ("player", self.displayedUnit)
--
--[[
    threatStatus
    
    nil = unit is not on otherunit's threat table.
    0 = not tanking, lower threat than tank.(탱커가 탱킹중이 아니지만 탱커보다 어글이 낮을때)
    1 = not tanking, higher threat than tank.(탱커가 탱킹중이 아니지만 탱커보다 어글이 높을때, ex)딜러위험.)
    2 = insecurely tanking, another unit have higher threat but not tanking.(안전하지 않은 탱킹, 탱커아닌 다른 유닛이 탱킹중)
    3 = securely tanking, highest threat(안전 탱킹)
--]]

--[[
local status, statustxts = UnitThreatSituation("player", "target"), { "low on threat",  "overnuking", "losing threat", "tanking securely" }
local r, g, b = GetThreatStatusColor(status)
print("You are " .. statustxts[status + 1] .. ".", r, g, b)


-- ThreatStatusColor
0: 0.69, 0.69, 0.69 -- 회색
1: 1, 1, 0.47       -- 노랑
2: 1, 0.6, 0        -- 주황
3: 1, 0, 0          -- 빨강
--]]

--[[
--CastingBarFrame_SetUnit(self.castBar, self.unit, false, true);

20191216
캐스트바에 대상명 추가 관련 시도시 사용했던 이벤트
=> 결론은 CastingBarFrame_OnShow 메소드 HOOK 했음

-- 타켓명을 넘겨주지만, 유져의 스킬시에만 발생
function AggroBorder:UNIT_SPELLCAST_SENT(...)
    local ll = {...};
    
    DebugPrint(ll);

end
--AggroBorder:RegisterEvent('UNIT_SPELLCAST_SENT');

-- 파악안됨
function AggroBorder:CURRENT_SPELL_CAST_CHANGED(...)
    local ll = {...};
    
    DebugPrint(ll);

end
--AggroBorder:RegisterEvent('CURRENT_SPELL_CAST_CHANGED');

-- UNIT_SPELLCAST_SENT
--
-- 
-- CURRENT_SPELL_CAST_CHANGED
-- 유져와 NPC 모두의 스킬시 발생하지만, 타켓을 알 방법이 없음.
-- 타켓은 NPC의 현 타켓으로 리턴해보았으나.. 잘못표현
function AggroBorder:UNIT_SPELLCAST_START(...)
    local ll = {...};
    --DebugPrint(ll);
    local unitId = ll[2];
    local startSpellId = ll[4];
    
    local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(startSpellId);

    local unitTargetId = unitId.."target";
    local unitTargetNm = UnitName(unitTargetId) or "";
    
    --print(unitTargetId..":"..unitTargetNm..":"..LJDGetClassColoredName(unitTargetNm));
    
    local plateFrame = C_NamePlate.GetNamePlateForUnit (unitId, issecure());
    if (not plateFrame) then
        return;
    end
    
    plateFrame.UnitFrame.castBar:HookScript("OnShow", function(self,...) 
        DebugPrint({...});
        self.Text:SetText(name.."["..LJDGetClassColoredName(unitTargetNm).."]");
    end);

end
--AggroBorder:RegisterEvent('UNIT_SPELLCAST_START');

-- 타켓변경시 발생
function AggroBorder:UNIT_TARGET(...)
    local ll = {...};
    local unitId = ll[2];
    --DebugPrint(ll);
    local unitTargetId = unitId.."target";
    --DebugPrint(unitTargetId);
    if( not UnitIsUnit("player", unitTargetId) ) then
        DebugPrint(unitTargetId);
    end
    if( UnitName(unitId.."target") ) then 
        DebugPrint(UnitName(unitId)..":"..UnitName(unitId.."target"));
    end

end
--AggroBorder:RegisterEvent('UNIT_TARGET');

-- SPELL_CAST_START 일때는 destGUID, destName 가 없음.
function AggroBorder:COMBAT_LOG_EVENT_UNFILTERED()

    local timestamp, type, hideCaster,                                                                                           -- arg1  to arg3
        sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags,                        -- arg4  to arg11
        spellId, spellName, spellSchool,                                                                                           -- arg12 to arg14
        extraSpellId,extraSpellName,extraSchool, resisted, blocked, absorbed, critical, glancing, crushing = CombatLogGetCurrentEventInfo()       -- arg15 to arg23

    if( type == "SPELL_CAST_START" ) then
            local ll = {CombatLogGetCurrentEventInfo()};
            --DebugPrint(destName);
            --DebugPrint(sourceName.."["..spellName.."] Casting..");
    end
end
--AggroBorder:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");

--]]

--[[
-- 20191216
-- 타켓프레임의 디버프 필터 참조용(TargetFrame.lua)
--
--		Hide debuffs on mobs cast by players other than me and aren't flagged to show to entire party on nameplates.
--
function TargetFrame_ShouldShowDebuffs(unit, caster, nameplateShowAll, casterIsAPlayer)
	if (GetCVarBool("noBuffDebuffFilterOnTarget")) then
		return true;
	end

	if (nameplateShowAll) then
		return true;
	end

	if (caster and (UnitIsUnit("player", caster) or UnitIsOwnerOrControllerOfUnit("player", caster))) then
		return true;
	end

	if (UnitIsUnit("player", unit)) then
		return true;
	end

	local targetIsFriendly = not UnitCanAttack("player", unit);
	local targetIsAPlayer =  UnitIsPlayer(unit);
	local targetIsAPlayerPet = UnitIsOtherPlayersPet(unit);

	if (not targetIsAPlayer and not targetIsAPlayerPet and not targetIsFriendly and casterIsAPlayer) then
        return false;
    end

    return true;
end
--]]

--[[
--    캐스팅중인 대상 출력 관련
name, text, texture, startTimeMS, endTimeMS, isTradeSkill, castID, notInterruptible, spellId = UnitCastingInfo("unit")
name, text, texture, startTimeMS, endTimeMS, isTradeSkill, notInterruptible, spellId = UnitChannelInfo("unit")
    
--]]

--[[
-- 20191225 RAIDTARGET 관련
0 = assign index to nil
1 = Yellow 4-point Star
2 = Orange Circle
3 = Purple Diamond
4 = Green Triangle
5 = White Crescent Moon
6 = Blue Square
7 = Red "X" Cross
8 = White Skull

SetRaidTarget("target", 8);
SetRaidTargetIcon("target", 8);
CompactRaidFrameManager
CompactRaidFrameManagerDisplayFrameLeaderOptionsRaidWorldMakerButton
IsRaidMarkerActive(index);
ClearRaidMarker(arg1);
PlaceRaidMarker(arg1);
    
--
-- Combat Log Icons
--
COMBATLOG_ICON_RAIDTARGET1			= "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_1.blp:0|t";
COMBATLOG_ICON_RAIDTARGET2			= "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_2.blp:0|t";
COMBATLOG_ICON_RAIDTARGET3			= "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_3.blp:0|t";
COMBATLOG_ICON_RAIDTARGET4			= "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_4.blp:0|t";
COMBATLOG_ICON_RAIDTARGET5			= "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_5.blp:0|t";
COMBATLOG_ICON_RAIDTARGET6			= "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_6.blp:0|t";
COMBATLOG_ICON_RAIDTARGET7			= "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7.blp:0|t";
COMBATLOG_ICON_RAIDTARGET8			= "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_8.blp:0|t";
--]]



--[[
-- 20200102 sort 관련

HighScore = { Robin = 8, Jon = 10, Max = 11 }

-- basic usage, just sort by the keys
for k,v in spairs(HighScore) do
    print(k,v)
end
--> Jon     10
--> Max     11
--> Robin   8

-- this uses an custom sorting function ordering by score descending
for k,v in spairs(HighScore, function(t,a,b) return t[b] < t[a] end) do
    print(k,v)
end
--> Max     11
--> Jon     10
--> Robin   8

function spairs(t, order)
    -- collect the keys
    local keys = {}
    
    -- 20200102 현재케릭의 스킬라인의 정렬순서를 앞으로
    for k in pairs(t) do keys[#keys+1] = k end

    -- if order function given, sort by it by passing the table and keys a, b,
    -- otherwise just sort the keys 
    if order then
        table.sort(keys, function(a,b) return order(t, a, b) end)
        --table.sort(keys, order)
        --table.sort(keys, function(a,b) return order(a, b) end)
        --table.sort(keys, LJDOrder)
    else
        table.sort(keys)
    end

    -- return the iterator function
    local i = 0
    return function()
        i = i + 1
        if keys[i] then
            return keys[i], t[keys[i] ]
        end
    end
end

-- 실패, sort 함수는 불안정하다.
function LJDOrder(t, a, b)
    -- sort함수에서의 리턴값
    -- valA  : 비교값1(기준값, [n])
    -- valB  : 비교값2(다음값, [n+1])
    -- false : 유지
    -- true  : 교체(비교값1을 위로 이동후 다시 비교)
    local valA = a;
    local valB = b;

    if( not valA or not valB ) then
        return false;
    end

    if( valA == 202 ) then
        --return true;
    end

    if( valA == 333 ) then
        --return true;
    end

    --if( valA > valB ) then -- 내림차순
    if( valA < valB ) then -- 오름차순
        return true;
    end
    
    return false;
end
--]]
--[[
-- 진득주)
1. table.sort를 이용한 정렬은 단순 List 형태(index-value)만 가능하다. ex. {"일","이","삼"}
2. table.sort는 List형이 아니면 sort함수를 지정하더라도 반응하지 않는다.
3. table(key-value)에 순차적으로 값을 넣는다고 해도 순서는 보장 받지 못한다.


종합적으로, 순서보장을 위해서는 List형태(index-value)를 사용하고,
저장된 데이터는 가공할수 없으므로 아래처럼 순차적으로 꺼내는 함수를 이용함.

Note that, for Lua, arrays also have no order. But we know how to count, so we get ordered values as long as we access the array with ordered indices. That is why you should always traverse arrays with ipairs, rather than pairs. The first imposes the key order 1, 2, ..., whereas the latter uses the natural arbitrary order of the table.

As a more advanced solution, we can write an iterator that traverses a table following the order of its keys. An optional parameter f allows the specification of an alternative order. It first sorts the keys into an array, and then iterates on the array. At each step, it returns the key and value from the original table:

    function pairsByKeys (t, f)
      local a = {}
      for n in pairs(t) do table.insert(a, n) end
      table.sort(a, f)
      local i = 0      -- iterator variable
      local iter = function ()   -- iterator function
        i = i + 1
        if a[i] == nil then return nil
        else return a[i], t[ a[i] ]
        end
      end
      return iter
    end
With this function, it is easy to print those function names in alphabetical order. The loop
    for name, line in pairsByKeys(lines) do
      print(name, line)
    end
will print
    luaH_get        24
    luaH_present    48
    luaH_set        10
    
--]]

--[[
-- 20200104 gsub 관련 유용한 사용예

-- example of using a function as the replacement

replacements = { 
   ["nice"] = "windy",
   ["walk"] = "stroll",
   }
   
s = "a nice long walk"

result = string.gsub (s, "%a+", 
  function (str)
  return replacements [str]
  end
  )

print (result) --> a windy long stroll

-- An alternative way of doing a table replacement using the above table:

result = string.gsub (s, "%a+", replacements)

--]]
