-----------------------------------------------------
-- lua 파일이 여러개인 경우
-- 애드온명, 애드온내공유테이블이 ...으로 전달됨
-----------------------------------------------------
local addonName, L = ...;

local Coordinate = CreateFrame("Button", "LJDCoordinateButton", UIParent);
Coordinate:SetScript('OnEvent', function(self, event, ...)
    return self[event] and self[event](self, event, ...)
end)

function Coordinate:PLAYER_ENTERING_WORLD()
        -- 좌표보기
    if( LJDSpellInterruptDB["ShowCoordinate"] ) then
        if( not self:IsShown() ) then
            self:CreateButton();
        end
        
        self:PrintCoordinate();
    end
end
Coordinate:RegisterEvent('PLAYER_ENTERING_WORLD');

function Coordinate:PLAYER_STARTED_MOVING(...)
    -- 움직이기 시작하면 좌표 갱신
    if( self:IsShown() ) then
        --self:SetScript("OnUpdate", self.PrintCoordinate );
        self:StartTimer();
    end
end
Coordinate:RegisterEvent('PLAYER_STARTED_MOVING');

function Coordinate:PLAYER_STOPPED_MOVING(...)
    -- 멈추면 갱신 중지
    --self:SetScript("OnUpdate", nil );
    self:StopTimer();
end
Coordinate:RegisterEvent('PLAYER_STOPPED_MOVING');

function Coordinate:CreateButton()
    --Button
    self:SetFrameStrata("BACKGROUND");
    --self:SetFrameStrata("HIGH");    -- 미니맵 앞으로..
    
    self:SetClampedToScreen(true);
    self:SetMovable(true);      -- 이동가능 : StartMoving() 사용가능.
    self:SetResizable(true);    -- 크기변경가능 : StartSizing() 사용가능.
    self:SetWidth(80); -- Set these to whatever height/width is needed 
    self:SetHeight(40); -- for your Texture
    
    --self:SetAllPoints(TimeManagerClockTicker);
    
    self:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",570, 155);
    --self:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",155, 570);
    --self:SetPoint("BOTTOMRIGHT",ChatFrame1Background,"TOPRIGHT",0, 0);
    --self:SetPoint("BOTTOM",Minimap,"BOTTOM",0, 0);
    --self:SetPoint("CENTER",TimeManagerClockButton,"CENTER",4, 2.5);
    --self:SetPoint("TOPLEFT",Minimap,"TOPLEFT",-21, 4);
    
    
    --TimeManagerClockTicker:Hide();
    --TimeManagerClockButton
    --TimeManagerClockTicker
    
    --[[
    self.tooltipText        = "채팅창이 활성화된 상태에서 클릭하면 좌표가 입력됩니다.\n(Ex.아이템링크)";  -- 툴팁
    self.tooltipRequirement = "클릭으로 좌표 입력";         -- 툴팁2
    self:RegisterForClicks("AnyUp");
    self:SetScript("OnEnter", function(self)
        if self.tooltipText then
            GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT")
            GameTooltip:SetText(self.tooltipText, 1.0, 1.0, 0.00, 0.75, true);
        end
        if self.tooltipRequirement then
            GameTooltip:AddLine(self.tooltipRequirement, 1.0, 1.0, 1.0)
            GameTooltip:Show()
        end
    end );
    self:SetScript("OnLeave", function(self)
        GameTooltip:Hide()
    end );
    --]]
    self:SetScript ("OnClick", function()
        -- 아이템링크 넣기처럼 좌표 넣기
        -- 채팅창 입력이 활성화 되어 있을때만 동작한다.
        local activeWindow = ChatEdit_GetActiveWindow();
        if ( activeWindow ) then
            activeWindow:Insert(self:GetCoordinate_ToChat());
        end        
    end );
    
    --[[
    self.border = self:CreateTexture(nil,"OVERLAY");
    self.border:SetTexture("Interface\\TimeManager\\ClockBackground");
    self.border:SetAllPoints();
    self.border:SetTexCoord( 0.015625, 0.8125, 0.015625, 0.390625);
    --self.border:SetTexCoord( 0, 1, 0, 1);
    --self.border:SetRotation(180,0,0);
    --]]
    
    -- 배경 UI 생성
    self.backgroundTexture = self:CreateTexture(nil,"OVERLAY");
    self.backgroundTexture:SetColorTexture(0.50,0.50,0.50,0.2);
    --self.backgroundTexture:SetColorTexture(1,1,1,0);  -- 완전투명
    self.backgroundTexture:SetAllPoints();

    -- Text UI 생성
    self.TextMapName = self:CreateFontString(nil, "OVERLAY");
    -- OUTLINE 은 폰트를 굵고 테두리가 표시 되도록하는 옵션이다.
    --self.TextMapName:SetFontObject("GameFontNormalLarge");
    self.TextMapName:SetFont([[Fonts\2002.TTF]], 13, "OUTLINE");
    self.TextMapName:SetPoint("TOPLEFT", self, "TOPLEFT", 0, 0);
    self.TextMapName:SetPoint("BOTTOMRIGHT", self, "RIGHT", 0, 1);
    
    --self.TextMapName:SetPoint("TOPLEFT", self ,"TOPLEFT", 6, 2);
    --self.TextMapName:SetPoint("BOTTOMRIGHT", self ,"BOTTOMRIGHT", 0, 0);
    
    --self.TextMapName:SetAllPoints(self);
    self.TextMapName:SetJustifyV("BOTTOM");
    --self.TextMapName:SetJustifyH("LEFT");
    self.TextMapName:SetText("맵이름"); -- 테스트용
    self.TextMapName:SetWordWrap(false); -- 자리넘어가면 .. 으로 대체

    -- Text UI 생성
    self.TextCoordinate = self:CreateFontString(nil, "OVERLAY");
    -- OUTLINE 은 폰트를 굵고 테두리가 표시 되도록하는 옵션이다.
    --self.TextCoordinate:SetFontObject("GameFontNormalLarge");
    self.TextCoordinate:SetFont([[Fonts\2002.TTF]], 15, "OUTLINE");
    self.TextCoordinate:SetPoint("TOPLEFT", self, "LEFT", 0, -1);
    self.TextCoordinate:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", 0, 0);
    
    --self.TextCoordinate:SetPoint("TOPLEFT", self ,"TOPLEFT", 6, 2);
    --self.TextCoordinate:SetPoint("BOTTOMRIGHT", self ,"BOTTOMRIGHT", 0, 0);
    
    --self.TextCoordinate:SetAllPoints(self);
    self.TextCoordinate:SetJustifyV("TOP");
    --self.TextCoordinate:SetJustifyH("LEFT");
    self.TextCoordinate:SetText("좌표"); -- 테스트용
    self.TextCoordinate:SetWordWrap(false); -- 자리넘어가면 .. 으로 대체

    self:Show();
    self.Shown = true;

    -----------------------------------------------------------------
    -- 버튼 이동가능하게 변경
    -- 주의, 저장된 버튼 정보LOAD를 LJDCenterButton.lua 에서 하므로
    -- toc 파일순서 주의.(LJDCenterButton.lua 위로 가야함.)
    -----------------------------------------------------------------
    LJDActionButton_SetMoveable(self);
    
    Coordinate:PrintCoordinate();
end

-- 채팅장에 보내기용 좌표문자열 반환
function Coordinate:GetCoordinate_ToChat()
    -- 현재 좌표 출력
    local map = C_Map.GetBestMapForUnit("player");
    if( not map ) then return ""; end;
    
    local mapInfo = C_Map.GetMapInfo(map);
    if( not mapInfo ) then return ""; end;
    
    local position = C_Map.GetPlayerMapPosition(map, "player")
    if( not position ) then return mapInfo.name; end;
    
    --return format("%s %.1f, %.1f",mapInfo.name, position.x*100,position.y*100);
    return format("%s %.0f:%.0f",mapInfo.name, position.x*100,position.y*100);
end

-- 좌표문자열 반환
function Coordinate:GetCoordinate()
    -- 현재 좌표 출력
    local map = C_Map.GetBestMapForUnit("player");
    if( not map ) then return "", ""; end;
    
    local mapInfo = C_Map.GetMapInfo(map);
    if( not mapInfo ) then return "", ""; end;
    --DebugPrintTable(mapInfo);
    --DebugPrintTable(C_Map.GetMapInfo(mapInfo.parentMapID));
    local position = C_Map.GetPlayerMapPosition(map, "player");
    if( not position ) then return mapInfo.name, ""; end;

    --return format("%s\n%.1f, %.1f",mapInfo.name,position.x*100,position.y*100);
    return mapInfo.name, format("%.0f:%.0f", position.x*100,position.y*100);
end

function Coordinate:PrintCoordinate(...)
    
    -- 현재 좌표 출력
    if( self:IsShown() ) then
        local mapName, coordnate = self:GetCoordinate();
        --[[
        if( mapName ~= "나즈자타" ) then
            self:Hide();
            return;
        else
            self:Show();
        end
        --]]
        
        self.TextMapName:SetText(mapName);
        self.TextCoordinate:SetText(coordnate);
    end
end

function Coordinate:IsShown()
    return (self.Shown ~= nil);
end

function Coordinate:StartTimer()
    --DebugPrint({...});
    --local timer = C_Timer.After(1, LJDCoordinateTimer);
    --local timer = C_Timer.NewTimer(1, LJDCoordinateTimer);
    --local ticker  = C_Timer.NewTicker(1, LJDCoordinateTimer,  0.016);
    --DebugPrintTable(ticker);
	if not self.ticker then
		self.ticker = C_Timer.NewTicker(1, function() self:onUpdate() end);
	end
    
    
end

function Coordinate:onUpdate()
    --DebugPrint("onUpdate");
    self:PrintCoordinate();
end

function Coordinate:StopTimer()
	if self.ticker then
		self.ticker:Cancel();
		self.ticker = nil;
	end
end

