-----------------------------------------------------
-- lua 파일이 여러개인 경우
-- 애드온명, 애드온내공유테이블이 ...으로 전달됨
-----------------------------------------------------
local addonName, L = ...;

local LJD_BTN_SIZE = 20;    -- 버튼크기

local frame = CreateFrame("FRAME");
frame:SetScript('OnEvent', function(self, event, ...)
    return self[event] and self[event](self, event, ...)
end)

function frame:PLAYER_ENTERING_WORLD()
    LJDWorldMarker_ReDraw();
end
frame:RegisterEvent('PLAYER_ENTERING_WORLD');

function LJDCreateRaidTargetFrame()

    if( _G["LJDWorldMarkerFrame"] ) then
        return;
    end

    local raidTargetFrame = CreateFrame("FRAME","LJDRaidTargetFrame",TargetFrameTextureFrame);
    raidTargetFrame:SetSize(225, 23);
    raidTargetFrame:SetPoint("BOTTOMLEFT", TargetFrameTextureFrame, "TOPLEFT", 0, 0);

    -- 디버그용 프레임 보기
    local texture = raidTargetFrame:CreateTexture(nil, "BACKGROUND");
    texture:SetAllPoints();
    texture:SetColorTexture(0,0,0,0.5);

    local btn1 = CreateFrame("BUTTON", nil, raidTargetFrame, "CRFManagerRaidIconButtonTemplate", 8);
    btn1:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn1:SetPoint("TOPLEFT", raidTargetFrame, "TOPLEFT", 20, 0);
    LJDRedrawButton(btn1);
    local btn2 = CreateFrame("BUTTON", nil, raidTargetFrame, "CRFManagerRaidIconButtonTemplate", 7);
    btn2:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn2:SetPoint("LEFT", btn1, "RIGHT", 0, 0);
    LJDRedrawButton(btn2);
    local btn3 = CreateFrame("BUTTON", nil, raidTargetFrame, "CRFManagerRaidIconButtonTemplate", 6);
    btn3:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn3:SetPoint("LEFT", btn2, "RIGHT", 0, 0);
    LJDRedrawButton(btn3);
    local btn4 = CreateFrame("BUTTON", nil, raidTargetFrame, "CRFManagerRaidIconButtonTemplate", 5);
    btn4:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn4:SetPoint("LEFT", btn3, "RIGHT", 0, 0);
    LJDRedrawButton(btn4);
    local btn5 = CreateFrame("BUTTON", nil, raidTargetFrame, "CRFManagerRaidIconButtonTemplate", 4);
    btn5:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn5:SetPoint("LEFT", btn4, "RIGHT", 0, 0);
    LJDRedrawButton(btn5);
    local btn6 = CreateFrame("BUTTON", nil, raidTargetFrame, "CRFManagerRaidIconButtonTemplate", 3);
    btn6:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn6:SetPoint("LEFT", btn5, "RIGHT", 0, 0);
    LJDRedrawButton(btn6);
    local btn7 = CreateFrame("BUTTON", nil, raidTargetFrame, "CRFManagerRaidIconButtonTemplate", 2);
    btn7:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn7:SetPoint("LEFT", btn6, "RIGHT", 0, 0);
    LJDRedrawButton(btn7);
    local btn8 = CreateFrame("BUTTON", nil, raidTargetFrame, "CRFManagerRaidIconButtonTemplate", 1);
    btn8:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn8:SetPoint("LEFT", btn7, "RIGHT", 0, 0);
    LJDRedrawButton(btn8);
    local btn0 = CreateFrame("BUTTON", nil, raidTargetFrame, "CRFManagerRaidIconButtonTemplate", 0);
    btn0:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn0:SetPoint("LEFT", btn8, "RIGHT", 10, 0);
    btn0:SetNormalTexture([=[Interface\Buttons\UI-GroupLoot-Pass-Up]=]);
    LJDRedrawButton(btn0);
    
    ChangeMoveableFrame(raidTargetFrame);
    
    raidTargetFrame:Hide();
end

function LJDCreateWorldMarkerFrame()

    if( _G["LJDWorldMarkerFrame"] ) then
        return;
    end
    
    local worldMarkerFrame = CreateFrame("FRAME","LJDWorldMarkerFrame",UIParent);
    worldMarkerFrame:SetSize(225, 23);
    worldMarkerFrame:SetPoint("TOP", UIParent, "TOP", 0, 0);

    -- 디버그용 프레임 보기
    local texture = worldMarkerFrame:CreateTexture(nil, "BACKGROUND");
    texture:SetAllPoints();
    texture:SetColorTexture(0,0,0,0.5);

    local btn1 = CreateFrame("Button", nil, worldMarkerFrame, "SecureActionButtonTemplate", 0); -- 0 유지(전체이미지)
    btn1:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn1:SetNormalTexture([=[Interface\TargetingFrame\UI-RaidTargetingIcon_6]=]);
    btn1:SetPoint("TOPLEFT", worldMarkerFrame, "TOPLEFT", 20, 0);
    btn1:SetAttribute("type1", "macro");
    btn1:SetAttribute("macrotext1", "/wm 1");
    LJDRedrawButton(btn1);
    local btn2 = CreateFrame("Button", nil, worldMarkerFrame, "SecureActionButtonTemplate", 0); -- 0 유지(전체이미지)
    btn2:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn2:SetNormalTexture([=[Interface\TargetingFrame\UI-RaidTargetingIcon_4]=]);
    btn2:SetPoint("LEFT", btn1, "RIGHT", 0, 0);
    btn2:SetAttribute("type1", "macro");
    btn2:SetAttribute("macrotext1", "/wm 2");
    LJDRedrawButton(btn2);
    local btn3 = CreateFrame("Button", nil, worldMarkerFrame, "SecureActionButtonTemplate", 0); -- 0 유지(전체이미지)
    btn3:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn3:SetNormalTexture([=[Interface\TargetingFrame\UI-RaidTargetingIcon_3]=]);
    btn3:SetPoint("LEFT", btn2, "RIGHT", 0, 0);
    btn3:SetAttribute("type1", "macro");
    btn3:SetAttribute("macrotext1", "/wm 3");
    LJDRedrawButton(btn3);
    local btn4 = CreateFrame("Button", nil, worldMarkerFrame, "SecureActionButtonTemplate", 0); -- 0 유지(전체이미지)
    btn4:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn4:SetNormalTexture([=[Interface\TargetingFrame\UI-RaidTargetingIcon_7]=]);
    btn4:SetPoint("LEFT", btn3, "RIGHT", 0, 0);
    btn4:SetAttribute("type1", "macro");
    btn4:SetAttribute("macrotext1", "/wm 4");
    LJDRedrawButton(btn4);
    local btn5 = CreateFrame("Button", nil, worldMarkerFrame, "SecureActionButtonTemplate", 0); -- 0 유지(전체이미지)
    btn5:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn5:SetNormalTexture([=[Interface\TargetingFrame\UI-RaidTargetingIcon_1]=]);
    btn5:SetPoint("LEFT", btn4, "RIGHT", 0, 0);
    btn5:SetAttribute("type1", "macro");
    btn5:SetAttribute("macrotext1", "/wm 5");
    LJDRedrawButton(btn5);
    local btn6 = CreateFrame("Button", nil, worldMarkerFrame, "SecureActionButtonTemplate", 0); -- 0 유지(전체이미지)
    btn6:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn6:SetNormalTexture([=[Interface\TargetingFrame\UI-RaidTargetingIcon_2]=]);
    btn6:SetPoint("LEFT", btn5, "RIGHT", 0, 0);
    btn6:SetAttribute("type1", "macro");
    btn6:SetAttribute("macrotext1", "/wm 6");
    LJDRedrawButton(btn6);
    local btn7 = CreateFrame("Button", nil, worldMarkerFrame, "SecureActionButtonTemplate", 0); -- 0 유지(전체이미지)
    btn7:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn7:SetNormalTexture([=[Interface\TargetingFrame\UI-RaidTargetingIcon_5]=]);
    btn7:SetPoint("LEFT", btn6, "RIGHT", 0, 0);
    btn7:SetAttribute("type1", "macro");
    btn7:SetAttribute("macrotext1", "/wm 7");
    LJDRedrawButton(btn7);
    local btn8 = CreateFrame("Button", nil, worldMarkerFrame, "SecureActionButtonTemplate", 0); -- 0 유지(전체이미지)
    btn8:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn8:SetNormalTexture([=[Interface\TargetingFrame\UI-RaidTargetingIcon_8]=]);
    btn8:SetPoint("LEFT", btn7, "RIGHT", 0, 0);
    btn8:SetAttribute("type1", "macro");
    btn8:SetAttribute("macrotext1", "/wm 8");
    LJDRedrawButton(btn8);
    local btn0 = CreateFrame("Button", nil, worldMarkerFrame, "SecureActionButtonTemplate", 0); -- 0 유지(전체이미지)
    btn0:SetSize(LJD_BTN_SIZE,LJD_BTN_SIZE);
    btn0:SetPoint("LEFT", btn8, "RIGHT", 10, 0);
    btn0:SetNormalTexture([=[Interface\Buttons\UI-GroupLoot-Pass-Up]=]);
    btn0:SetAttribute("type1", "macro");
    btn0:SetAttribute("macrotext1", "/cwm 0");
    LJDRedrawButton(btn0);
    
    ChangeMoveableFrame(worldMarkerFrame);
    
    worldMarkerFrame:Hide();
end

function LJDRedrawButton(btn)

    -- 클릭효과주기 Down
    if( not btn:GetScript("OnMouseDown") ) then
        btn:SetScript("OnMouseDown", function(self)
            PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON);
            self:GetNormalTexture():SetPoint("CENTER", self, "CENTER", -1, -1);
            
            if( not UnitInParty("player") ) then
                UIErrorsFrame:AddMessage(L["파티에 속해 있을때만 사용 가능합니다."], 1, 0, 0);
            end
        end);
    end
    -- 클릭효과주기 Up
    if( not btn:GetScript("OnMouseUp") ) then
        btn:SetScript("OnMouseUp", function(self)
            self:GetNormalTexture():SetPoint("CENTER", self, "CENTER", 0, 0);
        end);
    end

    local index = btn:GetID();
    local tex = btn:GetNormalTexture();
    local left = mod((index-1)/4, 1);
    local right = left + 0.25;
    local top = floor((index-1)/4) * 0.25;
    local bottom = top + 0.25;

    -- 버튼0은 이미지 모두 표시(별도 이미지니깐)
    -- 나머지 버튼들은 한 이미지파일에서 특정부분만 보여주도록 처리.
    if( index == 0 ) then
        left = 0;
        right = 1;
        top = 0;
        bottom = 1;
    end
    tex:SetTexCoord(left, right, top, bottom);

    tex:ClearAllPoints();
    tex:SetSize(btn:GetSize());
    tex:SetPoint("CENTER", btn, "CENTER", 0, 0);
end

function LJDWorldMarker_ReDraw()
    -- 레이드타켓마커
    LJDCreateRaidTargetFrame();
    if( LJDSpellInterruptDB["ShowRaidTargetMarker"] ) then
        _G["LJDRaidTargetFrame"]:Show();
    else
        if( _G["LJDRaidTargetFrame"] ) then
            _G["LJDRaidTargetFrame"]:Hide();
        end
    end

    -- 월드마커
    LJDCreateWorldMarkerFrame();
    if( LJDSpellInterruptDB["ShowWorldMarker"] ) then
        _G["LJDWorldMarkerFrame"]:Show();
    else
        if( _G["LJDWorldMarkerFrame"] ) then
            _G["LJDWorldMarkerFrame"]:Hide();
        end
    end
end